#!/bin/bash
source /etc/default/locale ; export LANG ; update-locale
AUTORUNWINTMP="/tmp/.${USER}-wine-autorun"
GPGVERIFY="/tmp/.${USER}-autolaunchers-verify-security"
GPGVERIFY2="/tmp/.${USER}-autolaunchers-verify-security_2"
WINPARSING="/tmp/.${USER}-autolaunchers-parsing-win"
IPODTMP="/tmp/.${USER}-ipod" # Do not delete this at the start of the script
rm -f $AUTORUNWINTMP $GPGVERIFY $GPGVERIFY2 $WINPARSING

source $HOME/.ivman/default

#set | grep LANG | grep UTF && source $HOME/.ivman/messages-utf8 || source $HOME/.ivman/messages-iso
source $HOME/.ivman/messages-utf8 


zenity-list(){
   zenity --list --title="$1" --text="$2" --column="" --column="Option" 1 "$3" 2 "$4" 3 "$5"
}

zenity-list2(){
   zenity --list --title="$1" --text="$2" --column="" --column="Option" 1 "$3" 2 "$4"
}

zenity-ask(){
   zenity --question --title="$1" --text="$2"
}

zenity-info(){
   zenity --info --text="$1"
}


umountmedia(){
   #zenity-ask "${MESSAGE[16]}" "${MESSAGE[17]}" && { umount $2 ; zenity-info "${MESSAGE[52]}" ; eject $2 ; exit 0 ; } || exit 0
   if mount | grep -q "$2"
   then
      if zenity-ask "${MESSAGE[16]}" "${MESSAGE[17]}"
      then
         mountpoint="`mount | grep $2 | awk '{print $3}' | tail -1`"
         #pumount $2 || umount -l $2 || {
         exo-mount -u -d "$2" || umount -l "$2" || {
            #         zenity --error --text="Error unmounting $2"
            exit 0
         }
         rm -f $mountpoint/.created_by_pmount 2>/dev/null
         rmdir $mountpoint 2>/dev/null
      else
         exit 0
      fi
   fi
}

audiocd(){
   $AUDIOCD2 &
   deprecated(){
      resultado=`( zenity-list "${MESSAGE[1]}" "${MESSAGE[2]}" "${MESSAGE[3]}" "${MESSAGE[4]}" "${MESSAGE[5]}" || echo cancel )`
      [ "$resultado" = "cancel" ] && { exit 1 ; }
      [ "$resultado" = "1" ] && { echo "now: $AUDIOCD1 $2" && $AUDIOCD1 $2 ; exit 0 ; }
      [ "$resultado" = "2" ] && { echo "now: $AUDIOCD2 $2" && $AUDIOCD2 $2 ; exit 0 ; }
      [ "$resultado" = "3" ] && { echo "now: $BURNER" && $BURNER ; exit 0 ; }
   }
}

blankcd(){
   ps aux | grep "$($BURNER|$BURNER2)" | grep -v grep | awk '{print $1}' | egrep -Eq "($USER|$UID)" && return
   zenity-ask "${MESSAGE[11]}" "${MESSAGE[12]}" && echo "now: $BURNER" && $BURNER && exit 0 
}

moviedvd(){
   resultado=`( zenity-list "${MESSAGE[31]}" "${MESSAGE[32]}" "${MESSAGE[33]}" "${MESSAGE[34]}" "${MESSAGE[35]}" || echo cancel )`
   [ "$resultado" = "cancel" ] && { exit 1 ; }
   [ "$resultado" = "1" ] && { echo "now: $DVDPLAYERF" && $DVDPLAYERF ; exit 0 ; }
   [ "$resultado" = "2" ] && { echo "now: $DVDPLAYER" && $DVDPLAYER ; exit 0 ; }
   [ "$resultado" = "3" ] && { echo "now: $RIPPER" && $RIPPER ; exit 0 ; }
}

movievcd(){
   resultado=`( zenity-list2 "${MESSAGE[41]}" "${MESSAGE[42]}" "${MESSAGE[43]}" "${MESSAGE[44]}" || echo cancel )`
   [ "$resultado" = "cancel" ] && { exit 1 ; }
   [ -e $HOME/.sunil-messages/ivman_vcd-vlc ] || { zenity-info "For a better work, try with VLC" ; mkdir -p $HOME/.sunil-messages/ ; touch $HOME/.sunil-messages/ivman_vcd-vlc ; }
   [ "$resultado" = "1" ] && { echo "now: $VCDPLAYERF" && $VCDPLAYERF ; exit 0 ; }
   [ "$resultado" = "2" ] && { echo "now: $VCDPLAYER" && $VCDPLAYER ; exit 0 ; }
}

winerror(){
   zenity --error --text=$"The emulation of windows has failed, please run 'winecfg' and configure it, is very possible that you need to check/uncheck the 'emulated audio' mode in the audio tab section, or just select a different version of Windows, try also the option of 'emulate a virtual desktop' (windowed mode) is also very possible that you need to install extra DLL's, or native versions, for that, select the Debug option in your Wine error window and search a message saying something about a DLL file not found', you can found extra DLL files in http://www.dlldump/ . Finally, the better option to know if some Game or Application works here, just visit http://appdb.winehq.com/ and search what you are trying to run, if you need to do any trick, is very possible that's explained on this page"
}

runwin(){
   $FM "$1" &
   if [[ ! -d $HOME/.wine ]] ; then
      zenity --info --text=$"If you have problems running this windows type CD, try to configure your wine application (run winecfg) and to enable the emulation of virtual desktop (windowed mode)"
   fi
   wine "$1" || winerror

   deprecated(){
      cedegahere=$(which cedega)
      [ -n $cedegahere ] && { wine "$1" || winerror ; } ||  { resultado=`( zenity --list --title="Windows Type CD" --text="Select one interpreter" --column="" --column="Option" 1 "Wine" 2 "Cedega" || echo cancel )`
      [ "$resultado" = "cancel" ] && return
      [ "$resultado" = "1" ] && { wine "$1" || winerror ; }
      [ "$resultado" = "2" ] && cedega "$1" ; }
   }
}

autorunwin(){
   [[ -d $HOME/.wine ]] && touch $HOME/.wine/.no_prelaunch_window_flag
   if ls -1 $mountpoint | grep -i autorun.inf
   then
      ficheroautorun="$( ls -1 $mountpoint | grep -i autorun.inf )"
      #echo $ficheroautorun
      cp $mountpoint/$ficheroautorun $AUTORUNWINTMP
      chmod +w $AUTORUNWINTMP
      dos2unix $AUTORUNWINTMP
      filepoint="$( echo "$(cat $AUTORUNWINTMP | grep -i "^open" | head -1 | sed 's/^.*=//g' | awk '{print $1}' )" )"
      filepoint="$( echo $filepoint | sed 's,\\,/,g' )"
      filepoint="$( find $mountpoint -iwholename '*'$filepoint'*')"
      runwin "$filepoint"
      rm -rf $AUTORUNWINTMP 2>/dev/null
      rm -rf $GPGVERIFY2 2>/dev/null
      umountmedia $*
   fi

   if ls -1 $mountpoint | grep -i autorun.exe
   then
      fileforlaunch="$( ls -1 $mountpoint | grep -i autorun.exe | head -1 )"
      runwin "$mountpoint/$fileforlaunch"
      rm -rf $GPGVERIFY2 2>/dev/null
      rm -rf $AUTORUNWINTMP 2>/dev/null
      umountmedia $*
   fi

   if ls -1 $mountpoint | grep -i autorun.bat
   then
      ficheroautorun="$( ls -1 $mountpoint | grep -i autorun.bat )"
      cp $mountpoint/$ficheroautorun $AUTORUNWINTMP 2>/dev/null
      chmod +w $AUTORUNWINTMP
      dos2unix $AUTORUNWINTMP
      cat $AUTORUNWINTMP | grep -i "^start" | head -1 | grep -i html && $BROWSER file:///$mountpoint/`( cat $AUTORUNWINTMP | grep -i "^start" | head -1 | grep -i html | sed 's/^.*=//g' )`
      rm -rf $AUTORUNWINTMP 2>/dev/null
      rm -rf $GPGVERIFY2 2>/dev/null
      umountmedia $*
   fi
}

elivecd(){
   rm -rf $GPGVERIFY 2>/dev/null
   exo-mount -u -d "$2" 2>/dev/null || umount "$2" 2>/dev/null || umount -l "$2" 2>/dev/null
   pmount -e $2
   mountpoint=`( mount | grep $2 | awk '{print $3}' )`
   cd $mountpoint/elive/launcher
   gpg --verify start.sh.sig 2>$GPGVERIFY || { 
      sed -i "s/\"//g" $GPGVERIFY
      zenity --error --text="${MESSAGE[60]} `cat $GPGVERIFY`"
      cd /
      rm -rf $GPGVERIFY 2>/dev/null
      umountmedia "$@"
   }
   keycode=`( cat $GPGVERIFY | grep ID | sed 's/^.*ID\ //g' )`

   #[[ "$keycode" = "2883D002" || "$keycode" = "your_key_ID_here" ]] && { 
   [[ "$keycode" = "2883D002" ]] && { 
      echo -e "$mountpoint $2" > $GPGVERIFY
      sh start.sh
      cd /
      rm -rf $GPGVERIFY 2>/dev/null
      umountmedia "$@"
   } || { 
      zenity --warning --text="${MESSAGE[61]}" && { 
         echo -e "$mountpoint $2" > $GPGVERIFY
         sh start.sh
         cd /
         rm -rf $GPGVERIFY 2>/dev/null
         umountmedia "$@"
      } || { cd / ; rm -rf $GPGVERIFY 2>/dev/null ; umountmedia "$@" ; }
   }
   # If you need a signature for an auto-launchement, contact Thanatermesis and send the script of needs the signature (if you make a future modification to this script the verification not is validate)
}



filemanager()
{
   mountpoint="$2"
   echo "mountpoint = $mountpoint"

   exo-mount -d "$2"

   if ! mount | grep -q "$2"
   then
      echo -e "Mountpoint $2 not mounted... exiting..."
      exit 0
   fi

   if [[ -f $IPODTMP ]]
   then
      # FIXME: do this better ?
      # FIXME: roxville tests
      pumount "$2" 2>/dev/null
      if [[ -d /media/ipod ]]
      then
         mount | grep -q "/media/ipod" || rm -rf /media/ipod
      fi

      pmount "$2" ipod
      echo -e "Launching iPod stuff in $(cat ${IPODTMP})"
      gtkpod # the option -a not seems to work anymore
      pumount "$2" 2>/dev/null && rm -rf /media/ipod
      eject "$2"
      rm -f $mountpoint/.created_by_pmount 2>/dev/null
      rmdir $mountpoint 2>/dev/null

      exit 0
   fi

   case `file -s $2` in 
   *ntfs*|*NTFS*)
      echo "Is a NTFS partition, we need to use NTFS-3g driver"
      if ! exo-mount -d "$2"
      then
         ntfsfix "$2"
         exo-mount -d "$2"
      fi
      ;;
   *)
      mountpoint="$( mount | grep "$2" | awk '{print $3}' )"
      if [[ -z "$mountpoint" ]]
      then
         exo-mount -d "$2"
         mountpoint="$( mount | grep "$2" | awk '{print $3}' )"
      fi
      ;;
   esac


   ##################################################
   ##################################################
   # Define the diferents types of CD's or systems: #
   ##################################################
   ##################################################

   # Windows Autostart files
   # last option (if not have another thing before...
   ls -1 $mountpoint > $WINPARSING
   if grep -iq autorun.inf $WINPARSING || grep -iq autorun.bat $WINPARSING || grep -iq autorun.exe $WINPARSING
   then
      #$FM "$2" &
      zenity --question --text="This media contains an Windows* autolaunchement system, do you want to run it ?" && autorunwin "$@"
   fi
   rm $WINPARSING 2>/dev/null

   # Elive system CD:
   [ -d "$mountpoint/elive/launcher" ] && elivecd $*

   # DVD Movie
   if [ -d "$mountpoint/VIDEO_TS" -o -d "$mountpoint/video_ts" ]
   then
      echo "DVD Movie found in $mountpoint"
      sleep 1
      pumount $mountpoint
      rm -f $mountpoint/.created_by_pmount 2>/dev/null
      rmdir $mountpoint 2>/dev/null
      echo "DEVICE UNMOUNTED"
      moviedvd $*
   else
      echo "Not is a DVD movie"
   fi
   # VCD Movie
   if [ -d "$mountpoint/MPEGAV" -o -d "$mountpoint/mpegav" -o -d "$mountpoint/mpeg2" ]
   then
      echo "VCD Movie found in $mountpoint"
      sleep 1
      pumount $mountpoint
      echo "DEVICE UNMOUNTED"
      movievcd $*
   else
      echo "Not is a VCD"
   fi

   # Debian Packages CD
   #[ -d "$mountpoint/pool" ] && { debianpackages $* ; }

   echo "now: $FM in $mountpoint"
   $FM "$mountpoint"
   #fmname="`readlink $FM`" # since thunar is not a link, this is not needed anymore
   fmname="$FM"
   [[ "`ps aux | grep -v grep | grep -E "($USER|$UID)" | grep $fmname | wc -l`" -ge 1 ]] && exit
   umountmedia $*
}

ipod()
{
   echo "$2" > $IPODTMP
   sleep 40
   rm -f $IPODTMP
}


ethernet()
{
   echo "1 = $1 , 2 = $2 , 3 = $3 , 4 = $4"
}


camera()
{
   $CAMERA
}

webcam()
{
   # exit directly, after suspend, webcam appears
   true
   # exit if we are on a eeepc
   #grep -i eeepc /etc/elive-version | grep -q special && return
   #$WEBCAM
}




case $1 in
-audiocd) audiocd $*
   ;;
-blankcd) blankcd $*
   ;;
-filemanager) filemanager $*
   ;;
-ethernet) ethernet $*
   ;;
-camera) camera $*
   ;;
-webcam) webcam $*
   ;;
-ipod) ipod $*
   ;;
esac
